// Uso do TMR2/4/6 modo 8 bits para contagem mxima de tempo

void main(){  //rotina principal do programa
#ifdef P18F45K22
  ANSELD = 0;
  ANSELB = 0;
#else
  ADCON1 |= 0X0F;
#endif

/**************** temporizao do timer2 ***************
  time_max = ciclo_maq. * PRESCALER * POSTSCALE * (PR2 + 1)
  time_max = 0.5us * 16 * 16 * (255 + 1)
  time_max: 32.768us >> ~33ms

******************************************************************************/
  T2CON = 0B01111111;  //define TIMER2 ON, prescaler 1:16, postscale 1:16
  PR2 =  255;          //contagem de 32ms
  // - o reg. ACC TMR2/4/6 conta e compara com PR2 a cada incremento
  // Neste exemplo ir incrementar at o mximo (255), quando TMR2 = PR2
  // Ocorrer o overflow: TMR2IF = 1 - que poderia ser usado para acionar
  // uma interrupo (vide exemplo de interrupo interna dos tirmers)
  // Neste caso, no entanto, no vamos usar interrupes, e vamos explorar somente
  // o uso do TMR2/4/6, portanto, aps o overflow, somente ser reiniciado o timer
  // que contar at 32 ms, piscando um LED neste intervalo

  PIR1.TMR2IF = 0;     //flag do TIMER2  inicialmente zerada

  //****************************************************************************
  TRISB.RB0 = 1;      //pino RB0 como entrada (boto)
  TRISB.RB1 = 1;      //pino RB1 como entrada
  //****************************************************************************
  TRISD.RD0 = 0;      //pino RD0 como sada (LED)
  PORTD.RD0 = 0;      //LED inicialmente apagado
  //****************************************************************************

while (1){

    if (PORTB.RB0 == 0) { // se a tecla rb0 for pressionada, ento...
         T2CON.TMR2ON = 1;  //ligar timer2
       }

    if (PORTB.RB1 == 0){  // se a tecla rb1 for pressionada, ento...
         T2CON.TMR2ON = 0; //desligar timer2
       }

    if (PIR1.TMR2IF == 1) {     //se ocorrer o estouro de contagem do TIMER2
         PORTD.RD0 = ~LATD.RD0; //inverte o estado lgico do led rd0
         PIR1.TMR2IF = 0;        //zera flag do TIMER2 aps o overflow (estouro)
        }

   }
 }